apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: {{ svc_gen_keypair }}
  namespace: {{ issuer_namespace | default(namespace) }}
spec:
{% if (cert_cn | default([])) | length > 0 %}
  commonName: {{ cert_cn[0] }}
{% if not (cert_is_ca | default(False)) %}
  dnsNames:
{% for cn in cert_cn %}
  - {{ cn }}
{% endfor %}
{% endif %}
{% else %}
  commonName: {{ svc_name }}.{{ namespace }}.svc.{{ cluster_domain }}
{% if not (cert_is_ca | default(False)) %}
  dnsNames:
  - {{ svc_name }}.{{ namespace }}.svc.{{ cluster_domain }}
  - {{ svc_name }}.{{ namespace }}.svc.cluster
  - {{ svc_name }}.{{ namespace }}.svc
  - {{ svc_name }}.{{ namespace }}
  - {{ svc_name }}
{% endif %}
  - {{ public_address | default(svc_address | default('127.0.0.1')) }}
{% endif %}
  duration: {{ ((svc_validity | default('365')) | int) * 24 }}h
{% if cert_is_ca | default(False) %}
  isCA: true
{% else %}
  isCA: false
{% endif %}
  issuerRef:
    name: {{ certmanager_issuer_name | default('selfsigned') }}
{% if issuer_cluster_scoped | default(False) %}
    kind: ClusterIssuer
{% else %}
    kind: Issuer
{% endif %}
{% if not (cert_is_ca | default(False)) %}
  ipAddresses:
  - {{ public_address | default(svc_address | default('127.0.0.1')) }}
  organization:
  - {{ ca_org }}
{% endif %}
  privateKey:
    algorithm: RSA
    encoding: PKCS1
    size: {{ svc_keylen | default('2048') }}
  renewBefore: 360h # 15d
  secretName: {{ svc_gen_keypair }}
{% if not (cert_is_ca | default(False)) %}
  uriSANs:
  - spiffe://cluster.local/ns/sandbox/sa/example
  usages:
  - server auth
  - client auth
{% endif %}
